﻿#include <hmg.ch>

Function Main

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ES850

  SET CENTURY ON
  SET DATE  BRITISH  
  SET ESCAPE ON

  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO UNICODE   

  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
      
  SET TOOLTIPSTYLE BALLOON
 
	DEFINE WINDOW Form_Main AT 100 , 100 WIDTH 452 HEIGHT 306 TITLE "DBF2MULTI" NOMAXIMIZE NOSIZE MAIN

                ON KEY ESCAPE ACTION Form_Main.Release  

		@ 040 , 020 BUTTON Btn_1 OF Form_Main CAPTION "MultiExport" WIDTH 100 HEIGHT 22 FONT "Verdana" SIZE 9   ;
			    ACTION (  Form_Main.LB_1.Value := UPPER( Getfile ( { {'Dbf Files','*.dbf'} } , 'Select File' , , .f. , .f., 1)), DbfToExcel( Form_Main.LB_1.Value ) )
		@ 080 , 020 BUTTON Btn_2 OF Form_Main CAPTION "Exit" WIDTH 100 HEIGHT 22 FONT "Verdana" SIZE 9  ACTION Form_Main.Release  
		@ 005 , 005 LABEL LB_1 OF Form_Main VALUE "" WIDTH 425 HEIGHT 20 FONT "Verdana" SIZE 10 FONTCOLOR WHITE BACKCOLOR BLUE

	END WINDOW

	Form_Main.Center
	Form_Main.Activate

Return
*------------------------------------------------------------------------*
Function DbfToExcel( cExcelName )
*------------------------------------------------------------------------*
	LOCAL oExcel  := nil
	LOCAL oActive := nil
        LOCAL cFile   := Form_Main.LB_1.Value
*------------------------------------------------------------------------*
  IF cFile <= SPACE(1)
     MsgInfo("No ha elegido Fichero","Atención")
     Return(.F.)
  ENDIF
*------------------------------------------------------------------------*
      cExcelNameA :=SUBSTR(cExcelName,1,len(cExcelName)-4)               // [ + PATH + File]  - ".dbf"   Sample -->  C:\TOOLS\SAMPLE\control
*     cExcelNameB :=ALLTRIM(substr(cFile,Rat('\',cFile)+1))              // - PATH [ + File   + ".dbf"]  Sample -->  ..\control.dbf
*     cExcelNameC :=LEFT(  cExcelNameB  , LEN(  cExcelNameB ) - 4 )      // - PATH [ + File ] - ".dbf"   Sample -->  ..\control
*------------------------------------------------------------------------*

        oExcel := CreateObject( "Excel.Application.12")   // Microsoft Excel 2007
	oExcel:WorkBooks:Open( cExcelName )
	oActive := oExcel:ActiveSheet()
	oExcel:DisplayAlerts := .F.               	// Doesn't display Excel alerts  
	oActive:PageSetup:Zoom := .F.                 	//Fit all columns in one page, and page orientation to landscape
	oActive:PageSetup:Orientation := 2 
	oActive:PageSetup:FitToPagesTall := .F.
	oActive:PageSetup:FitToPagesWide := 1                       
	oExcel:Visible := .F.                           // Do not show the excel file on screen 
	oExcel:ActiveWorkbook:ExportAsFixedFormat( 0, LOWER(cExcelNameA) + ".pdf")  
        oExcel:ActiveWorkbook:SaveAs( LOWER(cExcelNameA) + ".xls" ,-4143)  
	oExcel:Application:Quit()

	RELEASE oActive
	RELEASE oExcel

	Msginfo("Finished!!!","Done!")

Return
